﻿Type=Activity
Version=2.02
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
Sub Process_Globals
	Dim SelectedToDo As ToDos1
	Dim SelectedToDoIndex As Int				: SelectedToDoIndex = -1
	Dim ColorChecked As Int							: ColorChecked = Colors.RGB(0, 128, 0)
	Dim ColorUnChecked As Int						: ColorUnChecked = Colors.Red
End Sub

Sub Globals
	Dim scvToDoList As ScrollView
	Dim pnlToolBox, pnlToolsNew As Panel
	Dim lblFileName, lblFileName As Label
	Dim btnAdd, btnInsert, btnDelete, btnShift, btnEdit As Button
	Dim sldShift(2) As StateListDrawable
	Dim IME1 As IME
	Dim scvSepLineWidth As Int		: scvSepLineWidth = 2dip
	Dim scvCkbMargin As Int				: scvCkbMargin = 2dip
	Dim scvCkbHeight As Int				: scvCkbHeight = 40dip
	Dim scvItemWidth As Int	
	Dim scvItemWidthR As Int	
	Dim scvPnlHeight_1 As Int
	Dim scvPnlHeight As Int	

	Dim scvItemIdent As Int				: scvItemIdent = 40dip
	
	Dim Initialized As Boolean
	
	Dim bntNewX0, btnNewY0 As Float
End Sub

Sub Activity_Create(FirstTime As Boolean)
	IME1.Initialize("IME1")
	Activity.LoadLayout("ToDoList")
	scvPnlHeight_1 = scvCkbHeight + 2 * scvCkbMargin
	scvItemWidth = scvToDoList.Width - 2 * scvItemIdent
	scvPnlHeight = scvPnlHeight_1 + scvSepLineWidth
	pnlToolBox.Top = 100%y - pnlToolBox.Height
	scvToDoList.Height = pnlToolBox.Top - lblFileName.Height
	lblFileName.Text = Main.ToDoFileName
	InitButtonBitmaps
End Sub

Sub Activity_Resume
	Activity.Title = Main.ProgName & "  " & Main.ProgVersion
	Initialized = False
	If Main.ToDo.Size = 0 Then
		btnAdd_Click
	Else
		FillScrollView
		If SelectedToDoIndex > -1 Then
			btnShift.Background = sldShift(SelectedToDo.Ident)
			SelectToDo(SelectedToDoIndex, False)
			scvToDoList.ScrollPosition = SelectedToDoIndex * scvPnlHeight
		End If
		Initialized = True
	End If 
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If Main.SaveFileAutomatically = True Then
		gen.SaveToDoList
	End If
End Sub

Sub FillScrollView
	Dim I As Int
	
	For I = 0 To scvToDoList.Panel.NumberOfViews - 1
		scvToDoList.Panel.RemoveViewAt(0)
	Next
	
	For I = 0 To Main.ToDo.Size - 1
		Dim tdo As ToDos1
		tdo = Main.ToDo.Get(I)
		
		Dim pnl As Panel
		pnl.Initialize("")
		scvToDoList.Panel.AddView(pnl, 0, I * scvPnlHeight + scvSepLineWidth, scvToDoList.Width, scvPnlHeight_1)
		pnl.Tag = I
		If I = SelectedToDoIndex Then
			pnl.Color = Main.ColSelected
		Else
			pnl.Color = Main.ColBackground
		End If
		
		Dim ckb As CheckBox
		ckb.Initialize("ckbToDo")
		pnl.AddView(ckb, tdo.Ident * scvItemIdent, scvCkbMargin, scvCkbHeight, scvCkbHeight)
		ckb.Tag = I
		ckb.Text = ""
		ckb.Checked = tdo.Checked
	
		Dim lbl As Label
		lbl.Initialize("lblToDo")
		pnl.AddView(lbl, tdo.Ident * scvItemIdent + scvCkbHeight, 0, scvItemWidth, scvPnlHeight_1)
		lbl.Tag = I
		lbl.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
		lbl.TextSize = 18
		If tdo.Checked = True Then
			lbl.TextColor = ColorChecked
		Else
			lbl.TextColor = ColorUnChecked
		End If
		lbl.Text = tdo.Name
	Next
	scvToDoList.Panel.Height = I * scvPnlHeight + scvSepLineWidth
End Sub

Sub ckbToDo_CheckedChange(Checked As Boolean)
	Dim ckb As CheckBox
	Dim lbl As Label
	Dim pnl As Panel
	
	If 	Initialized = False Then
		Return
	End If

	ckb = Sender
	ckb.Checked = Checked
	
	Dim tdo As ToDos1
	tdo = Main.ToDo.Get(ckb.Tag)
	tdo.Checked = Checked
	pnl = scvToDoList.Panel.GetView(ckb.Tag)
	lbl = pnl.GetView(1)
	If Checked = True Then
		lbl.TextColor = ColorChecked
	Else
		lbl.TextColor = ColorUnChecked
	End If
	Main.ToDoChanged = True
End Sub

Sub btnShift_Click
	Dim pnl As Panel
	Dim cbk As CheckBox
	Dim lbl As Label
	
	pnl = scvToDoList.Panel.GetView(SelectedToDoIndex)
	cbk = pnl.GetView(0)
	lbl = pnl.GetView(1)
	If SelectedToDo.Ident = 0 Then
		SelectedToDo.Ident = 1
	Else
		SelectedToDo.Ident = 0 
	End If
	cbk.Left = SelectedToDo.Ident * scvItemIdent
	lbl.Left = SelectedToDo.Ident * scvItemIdent + scvCkbHeight
	btnShift.Background = sldShift(SelectedToDo.Ident)
	Main.ToDoChanged = True
End Sub

Sub btnEdit_Click
	Edit.Mode = Edit.cEdit
	StartActivity(Edit)
End Sub

Sub btnAdd_Click
	Edit.Mode = Edit.cAdd
	StartActivity(Edit)
End Sub

Sub btnInsert_Click
	Edit.Mode = Edit.cInsert
	StartActivity(Edit)
End Sub

Sub btnDelete_Click
	Dim answ, I As Int
	
'	answ = Msgbox2("Do you really want to delete this item", "Delete", "Yes", "", "No", Null)
	answ = Msgbox2(Main.Texts(12), Main.Texts(13), Main.Texts(3), "", Main.Texts(4), Null)
	If answ = DialogResponse.POSITIVE Then
		Main.ToDo.RemoveAt(SelectedToDoIndex)
		If SelectedToDoIndex < Main.ToDo.Size - 1 Then
			For I = SelectedToDoIndex To Main.ToDo.Size - 2
				Dim ckb, ckb1 As CheckBox
				Dim lbl, lbl1 As Label
				Dim pnl, pnl1 As Panel
				pnl = scvToDoList.Panel.GetView(I)
				ckb = pnl.GetView(0)
				lbl = pnl.GetView(1)
				pnl1 = scvToDoList.Panel.GetView(I + 1)
				ckb1 = pnl1.GetView(0)
				lbl1 = pnl1.GetView(1)
				ckb.Checked = ckb1.Checked
				lbl.Text = lbl1.Text
			Next
			SelectToDo(-1, True)
		Else
			SelectedToDoIndex = -1
		End If
		scvToDoList.Panel.RemoveViewAt(Main.ToDo.Size)
		Main.ToDoChanged = True
	End If
End Sub

Sub lblToDo_Click
	Dim lbl As Label
	Dim i As Int
	
	lbl = Sender
	i = lbl.Tag 
	SelectToDo(i, True)
	btnShift.Background = sldShift(SelectedToDo.Ident)
End Sub

Sub lblToDo_LongClick
	lblToDo_Click
	btnEdit_Click
End Sub

Sub SelectToDo(Index As Int, Unselect As Boolean)
	Dim pnl As Panel
	
	If SelectedToDoIndex > -1 Then			' releases the current selection
		pnl = scvToDoList.Panel.GetView(SelectedToDoIndex)
		pnl.Color = Main.ColBackground
	End If
	
	If SelectedToDoIndex = Index AND Unselect = True Then	' unselects a selected item 
		Index = -1
	End If
	
	SelectedToDoIndex = Index					' sets the new selection
	
	If SelectedToDoIndex = -1 Then			' if no selection return
		btnEdit.Visible = False
		btnInsert.Visible = False
		btnDelete.Visible = False
		btnShift.Visible = False
		Return
	End If
	SelectedToDo = Main.ToDo.Get(SelectedToDoIndex)
	btnEdit.Visible = True
	btnDelete.Visible = True
	btnInsert.Visible = True
	btnShift.Visible = True
	
	pnl = scvToDoList.Panel.GetView(SelectedToDoIndex)
	pnl.Color = Main.ColSelected
	pnl.Invalidate
End Sub

Sub InitButtonBitmaps
	Dim bdwEnabled As BitmapDrawable
	bdwEnabled.Initialize(LoadBitmap(File.DirAssets, "btnShiftToDoR0.png"))
	Dim bdwPressed As BitmapDrawable
	bdwPressed.Initialize(LoadBitmap(File.DirAssets, "btnShiftToDoR1.png"))
	Dim stdBitmap As StateListDrawable
	sldShift(0).Initialize
	Dim states(2) As Int
	states(0) = sldShift(0).state_enabled
	states(1) = -sldShift(0).state_pressed
	sldShift(0).addState2(states, bdwEnabled)
	Dim states(1) As Int
	states(0) = sldShift(0).state_enabled
	sldShift(0).addState2(states, bdwPressed)
	
	Dim bdwEnabled As BitmapDrawable
	bdwEnabled.Initialize(LoadBitmap(File.DirAssets, "btnShiftToDoL0.png"))
	Dim bdwPressed As BitmapDrawable
	bdwPressed.Initialize(LoadBitmap(File.DirAssets, "btnShiftToDoL1.png"))
	Dim stdBitmap As StateListDrawable
	sldShift(1).Initialize
	Dim states(2) As Int
	states(0) = sldShift(1).state_enabled
	states(1) = -sldShift(1).state_pressed
	sldShift(1).addState2(states, bdwEnabled)
	Dim states(1) As Int
	states(0) = sldShift(1).state_enabled
	sldShift(1).addState2(states, bdwPressed)	
End Sub

